'use strict';
import React from 'react'
import { connect }  from 'react-redux';
import HeaderComponent from '../../components/CommonComponent/HeaderComponent/HeaderComponent'
import PopupComponent from '../../components/CommonComponent/PopupComponent/PopupComponent'
import TroubleContainer from '../TroubleContainer/TroubleContainer'
import TextAreaContainer from '../TextAreaContainer/TextAreaContainer'
import ScanBarCodeContainer from '../ScanBarCodeContainer/ScanBarCodeContaienr'
import ReportDamagesListContainer from '../ReportDamagesListContainer/ReportDamagesListContainer'
require('./index.css')
const showPage = {
    1 : 'Trouble',
    2 : 'Scan',
    4 : 'TextArea'
};

const defaultPopupInfo = {
        showPopup : false, //是否显示弹窗
        popupChild : null, // 自定义弹窗内部html
        popupText : "", //默认弹窗的文本 （必填）
        popupButtons : [], // 默认弹窗的按钮
        classNames : '' //自定义类名
    };

class PageContainer extends React.Component {
    constructor(props) {
        super(props);
        // UTILPATH.socket.getIp();
        this.state = {
            showPage : showPage[4],
            page : null,
            popupInfo : defaultPopupInfo,

        };
        this.getPages = this.getPages.bind(this);
        this.showPopup = this.showPopup.bind(this);
        this.hidePopup = this.hidePopup.bind(this);
    }
    componentWillMount() {
        let pages = this.getPages();
        this.setState({
            page : pages
        })
    }
    componentDidMount(){
    }
    componentDidUpdate() {
    }
    componentWillReceiveProps(nextProps){
    }
    componentWillUnmount(){
    }

    hidePopup(){
        this.setState({
            popupInfo : defaultPopupInfo
        })
    }
    showPopup(info){
        //eg : info = {popupText:'test',popupButtons:[{text : '返回',option:FUNCTION}]}
        let popupInfo = Object.assign({},defaultPopupInfo,info);
        if(
            (   popupInfo.popupChild ||
                popupInfo.popupText ||
                (popupInfo.popupButtons && popupInfo.popupButtons.length > 0)
            ) && !popupInfo.showPopup
        ){
            popupInfo.showPopup = true; //以防未设置显示弹窗，做此判断。
        }

        this.setState({
            popupInfo : popupInfo,
        })
    }

    getPages(){
        let pages = null;
        switch (this.state.showPage){
            case showPage[1]:
                pages = <TroubleContainer />;
                break;
            case showPage[2]:
                pages = <ScanBarCodeContainer />;
                break;
            case showPage[4]:
                pages = <TextAreaContainer />
        }
        return pages;
    }

    render() {
        return (
            <div className={"pageContainer " + "backColfff"}>
                <HeaderComponent />
                <PopupComponent popupInfo={this.state.popupInfo} />
                {this.state.page}
            </div>
        )
    }
}

function select(store) {
    return Object.assign({}, {state: store})
}

export default connect(select)(PageContainer)